.\"
.\"	SWISH++
.\"	searchmonitor.8
.\"
.\"	Copyright (C) 2001  Paul J. Lucas
.\"
.\"	This program is free software; you can redistribute it and/or modify
.\"	it under the terms of the GNU General Public License as published by
.\"	the Free Software Foundation; either version 2 of the License, or
.\"	(at your option) any later version.
.\"
.\"	This program is distributed in the hope that it will be useful,
.\"	but WITHOUT ANY WARRANTY; without even the implied warranty of
.\"	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\"	GNU General Public License for more details.
.\"
.\"	You should have received a copy of the GNU General Public License
.\"	along with this program; if not, write to the Free Software
.\"	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.\"
.\" ---------------------------------------------------------------------------
.TH \f3searchmonitor\fP 8 "November 11, 2001" "SWISH++"
.SH NAME
searchmonitor \- SWISH++ search daemon monitor
.SH SYNOPSIS
.B searchmonitor
[
.B \-c
.I conf_file
]
[
.B \-s
.I search_path
]
.SH DESCRIPTION
.B searchmonitor
is a process monitor for
.BR search (1)
when it is running as a daemon.
If the process exits because of a condition that restarting might cure,
it will automatically be restarted.
.PP
.B searchmonitor
is typcially called from a system start script such as
.BR searchd (8)
(for SysV-like systems) or \f(CWrc.local\f1 (for BSD-like systems).
.SS Restartable Conditions
The following conditions will cause a restart:
.TP 3
\(bu
A create, bind, or listen to a TCP or Unix domain socket fails.
.TP
\(bu
A select or an accept on a socket fails.
.TP
\(bu
Creating or detaching a thread fails.
.TP
\(bu
Initializing a thread mutex or condition fails.
.TP
\(bu
Any unaccounted-for exit status.
.PP
Restartable conditions are logged via
.BR syslogd (8)
at the \f(CWERR\f1 level.
There is a 5-second sleep before the process is restarted
to prevent tight loops.
.SS Unrestartable Conditions
The following conditions will
.I not
cause a restart:
.TP 3
\(bu
Error in configuration file.
.TP
\(bu
Error in command-line.
.TP
\(bu
Reading the index file fails.
.TP
\(bu
Writing the PID file fails.
.TP
\(bu
Deleting an old Unix domain socket file fails.
.TP
\(bu
Changing directory to \f(CW/\f1 fails.
.TP
\(bu
The user or group the process is attempting to change its
user and group ID to does not exist.
.TP
\(bu
The process received a USR2 signal
in response to a manual shutdown request.
.PP
With the exception of USR2,
unrestartable conditions are logged via
.BR syslogd (8)
at the \f(CWALERT\f1 level.
.SH OPTIONS
.TP 15
.TP
.BI \-c conf_file
The name of the configuration file,
.IR f ,
to use.
If none is given,
\f(CWswish++.conf\f1 is tried
both in the current directory and in \f(CW/etc\f1.
.TP
.BI \-s search_path
The full path to the location of
.BR search (1).
(Default is whereever it was installed.
The default for that is \f(CW/usr/local/bin/search\f1.)
.SH FILES
.PD 0
.TP 28
\f(CWswish++.conf\f1
default configuration file
.TP
\f(CW/usr/local/bin/search\f1
Default location for
.BR search (1)
.PD
.SH SEE ALSO
.BR search (1),
.BR swish++.conf (4),
.BR searchd (8),
.BR syslogd (8)
.SH AUTHOR
Paul J. Lucas
.RI < pauljlucas@mac.com >
